//########## The Director

//### Sounds

datablock AudioProfile(EZM_CountdownSound)
{
  filename = "./countdown.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(EZM_GameOverSound)
{
  filename = "./GameOver.wav";
  description = AudioClose3d;
  preload = true;
};

//### Bricks

datablock fxDTSBrickData(EZM_BotSpawnData)
{
  brickFile = "./4x4x1round.blb";
  category = "Special";
  subCategory = "Bots";
  uiName = "Zombie Spawn";
  iconName = "";
};

//### Functions

function Slayer_EZM_onModeStart(%mini)
{
  %mini.isEZM = true;
  %mini.EZM_Wave = 1;
  %mini.EZM_BossCount = 0;
  %mini.EZM_ZombieCount = 0;
  %mini.EZM_ZombieWaveCount = 0;
  %mini.EZM_ZombieKillOffTimer = 0;
  %mini.EZM_IsSpecialWave = 0;
  %mini.EZM_LastSpecialWave = -1;
  %mini.EZM_SuddenDeathTimer = 0;
  %mini.EZM_Tick = schedule(1000,0,Slayer_EZM_Tick,%mini);
}

function Slayer_EZM_onModeEnd(%mini)
{
  %mini.isEZM = "";
  cancel(%mini.EZM_Tick);
  while(EZMZombies.getCount() > 0) EZMZombies.getObject(0).delete();
}

function Slayer_EZM_preReset(%mini,%client)
{
  cancel(%mini.EZM_Tick);
  while(EZMZombies.getCount() > 0) EZMZombies.getObject(0).delete();
}

function Slayer_EZM_postReset(%mini,%client)
{
  cancel(%mini.EZM_Tick);
  %mini.EZM_Wave = 1;
  %mini.EZM_WavePause = "";
  %mini.EZM_BossCount = 0;
  %mini.EZM_ZombieCount = 0;
  %mini.EZM_ZombieWaveCount = 0;
  %mini.EZM_ZombieKillOffTimer = 0;
  %mini.EZM_IsSpecialWave = 0;
  %mini.EZM_LastSpecialWave = -1;
  %mini.EZM_SuddenDeathTimer = -1;
  %mini.EZM_Tick = schedule(1000,0,Slayer_EZM_Tick,%mini);
}

function Slayer_EZM_onJoin(%mini,%client)
{
  if(%mini.numMembers < 2)
  {
    %mini.reset();
    return;
  }
  if(%mini.EZM_WavePause > 0) %client.chatMessage("\c3Wave \c2" @ %mini.EZM_Wave @ "\c3 will begin in " @ %mini.EZM_WavePause @ " seconds!");
  else if(%mini.EZM_WavePause == -1)
  {
    if(%mini.lives > 0)
    {
      %client.setDead(1);
      %client.setLives(0);
      if(isObject(%client.player)) %client.player.delete();
      %client.spectateInit(%this);
      %client.chatMessage("\c3You will spawn once the round has ended!");
      %client.centerprint(0,1," ");
    }
    %client.chatMessage("\c3It's wave \c2" @ %mini.EZM_Wave @ "\c3, \c2" @ %mini.EZM_ZombieCount + %mini.EZM_ZombieWaveCount + %mini.EZM_BossCount @ "\c3 zombies are left!");
  }
  %client.incScore(%mini.EZM_LateJoinWavePoints * (%mini.EZM_Wave - 1));
}

function Slayer_EZM_onSpawn(%mini,%client)
{
  %timediff = (%mini.EZM_SuddenDeathTimeLimit*60) - %mini.EZM_SuddenDeathTimer;
  if(%timediff < 1)
    if(%mini.EZM_SuddenDeath == 0)
      %client.player.setDamageLevel(%client.player.dataBlock.maxDamage - 1);
}

function Slayer_EZM_Tick(%mini)
{
  cancel(%mini.EZM_Tick);
  if(!isObject(%mini)) return;
  %mini.EZMTick = schedule(1000,0,Slayer_EZM_Tick,%mini);
  if(%mini.EZM_WavePause $= "") %mini.EZM_WavePause = %mini.EZM_WaveDelay;
  // Wave preparation countdown
  if(%mini.EZM_WavePause > 0)
  {
    if(%mini.EZM_WavePause == 2)
    {
      for(%i=0;%i<%mini.numMembers;%i++) %mini.member[%i].play2d("EZM_Countdownsound");
    }
    if(%mini.EZM_WavePause == 120) %mini.messageAll(0,"\c3Wave \c2" @ %mini.EZM_Wave @ "\c3 will begin in two minutes!");
    else if(%mini.EZM_WavePause == 60) %mini.messageAll(0,"\c3Wave \c2" @ %mini.EZM_Wave @ "\c3 will begin in one minute!");
    else if(%mini.EZM_WavePause == 30) %mini.messageAll(0,"\c3Wave \c2" @ %mini.EZM_Wave @ "\c3 will begin in 30 seconds!");
    else if(%mini.EZM_WavePause == 15) %mini.messageAll(0,"\c3Wave \c2" @ %mini.EZM_Wave @ "\c3 will begin in 15 seconds!");
    %mini.EZM_WavePause -= 1;
  }
  // Start wave
  else if(%mini.EZM_WavePause == 0)
  {
    %mini.EZM_ZombieWaveCount = %mini.EZM_ZombieAmount + (%mini.EZM_ZombieAmountInc * %mini.EZM_Wave - 1);
    %mini.EZM_WavePause = -1;
    if(%mini.EZM_Wave/5 == (%mini.EZM_Wave/5 << 0))
    {
      %mini.EZM_BossCount = 1 + (%mini.EZM_Wave/%mini.EZM_BossCountInc << 0);
      %mini.messageAll(0,"\c3Boss wave \c2" @ %mini.EZM_Wave @ "\c3 has begun!");
    }
    else if(%mini.EZM_AllowSpecialWaves && %mini.EZM_LastSpecialWave + 3 <= %mini.EZM_Wave && !getRandom(3))
    {
//      %mini.EZM_ZombieWaveCount *= 1.5;
      %len = %rnd = 0;
      while($EZM_Zombies[%len,"Name"] !$= "") %len += 1;
      %type = -1;
      while(%type != 1)
      {
        %rnd = getRandom(%len);
        if($EZM_Zombies[%rnd,"SpecialWave"] == 1)
        {
          %allow = -1;
          if($EZM_Zombies[%rnd,"Allow"] !$= -1) eval("%allow = %mini." @ $EZM_Zombies[%rnd,"Allow"] @ "; $evalNoError = 0;");
          if(%allow $= 1) { %type = %rnd; break; }
        }
      }
      %mini.EZM_SpecialWaveZombieType = %type;
      %mini.EZM_IsSpecialWave = 1;
      %mini.messageAll(0,"\c3Special wave \c2" @ %mini.EZM_Wave @ "\c3 has begun!");
    }
    else
    {
      %mini.messageAll(0,"\c3Wave \c2" @ %mini.EZM_Wave @ "\c3 has begun!");
    }
  }
  // In the middle of a wave
  else if(%mini.EZM_WavePause == -1)
  {
    // End wave
    if(%mini.EZM_ZombieCount < 1 && %mini.EZM_ZombieWaveCount < 1 && %mini.EZM_BossCount < 1)
    {
      %mini.EZM_SuddenDeathTimer = -1;
      if(%mini.lives > 0 && %mini.EZM_ResetLives == 1)
      {
        %playercount = %mini.numMembers;
        for(%i=0;%i<%mini.numMembers;%i++)
        {
          %lives = %mini.member[%i].getLives();
          %mini.member[%i].setLives(%mini.lives);
          if(%lives < 1 && !isObject(%mini.member[%i].player)) {
            if(%mini.EZM_WaveSurvivalPoints) %mini.member[%i].chatMessage("\c3A shame you died, you get no points for that! Wave \c2" @ %mini.EZM_Wave + 1 @ "\c3 will begin in \c2" @ %mini.EZM_WaveDelay @ "\c3 seconds!");
            else
              %mini.member[%i].chatMessage("\c3A shame you died! Wave \c2" @ %mini.EZM_Wave + 1 @ "\c3 will begin in \c2" @ %mini.EZM_WaveDelay @ "\c3 seconds!");
            %mini.member[%i].setDead(0);
            %mini.member[%i].instantRespawn();
            bottomPrint(%mini.member[%i]," ",1); }
          else {
            if(!isObject(%mini.member[%i].player)) %mini.member[%i].instantRespawn();
            if(%mini.EZM_WaveSurvivalPoints) {
              %mini.member[%i].chatMessage("\c3You survived wave \c2" @ %mini.EZM_Wave @ "\c3 (\c2+" @%mini.EZM_WaveSurvivalPoints @"\c3 points)! Wave \c2" @ %mini.EZM_Wave + 1 @ "\c3 will begin in \c2" @ %mini.EZM_WaveDelay @ "\c3 seconds!");
              %mini.member[%i].incScore(%mini.EZM_WaveSurvivalPoints); }
            else
              %mini.member[%i].chatMessage("\c3You survived wave \c2" @ %mini.EZM_Wave @ "\c3! Wave \c2" @ %mini.EZM_Wave + 1 @ "\c3 will begin in \c2" @ %mini.EZM_WaveDelay @ "\c3 seconds!"); }
        }
      }
      else
      {
        %playercount = %mini.numMembers;
        for(%i=0;%i<%mini.numMembers;%i++)
        {
          if(%mini.EZM_WaveSurvivalPoints) {
            %mini.member[%i].chatMessage("\c3You survived wave \c2" @ %mini.EZM_Wave @ "\c3 (\c2+" @%mini.EZM_WaveSurvivalPoints @"\c3 points)! Wave \c2" @ %mini.EZM_Wave + 1 @ "\c3 will begin in \c2" @ %mini.EZM_WaveDelay @ "\c3 seconds!");
            %mini.member[%i].incScore(%mini.EZM_WaveSurvivalPoints); }
          else
            %mini.member[%i].chatMessage("\c3You survived wave \c2" @ %mini.EZM_Wave @ "\c3! Wave \c2" @ %mini.EZM_Wave + 1 @ "\c3 will begin in \c2" @ %mini.EZM_WaveDelay @ "\c3 seconds!");
        }
      }
      %mini.EZM_WavePause = %mini.EZM_WaveDelay;
      %mini.EZM_Wave += 1;
      %mini.EZM_IsSpecialWave = 0;
    }
    else if(%mini.EZM_ZombieCount < 5 && %mini.EZM_ZombieWaveCount < 1)
    {
      if(%mini.EZM_BossCount > 0) Slayer_EZM_SpawnBoss(%mini);
      if(EZMZombies.getCount())
      {
        if(%mini.EZM_ZombieKillOffTimer > 15)
        {
          %fag = EZMZombies.getObject(0);
          if(!%fag.EZMisBoss) %fag.kill();
          %mini.EZM_ZombieKillOffTimer = 0;
        }
        %mini.EZM_ZombieKillOffTimer += 1;
      }
      Slayer_EZM_UpdateBossHealth(%mini);
    }
    else if(%mini.EZM_ZombieCount < %mini.EZM_ZombieAmountMaxSpawned)
    {
      Slayer_EZM_SpawnWave(%mini);
    }
    if(%mini.EZM_SuddenDeathTimeLimit)
    {
      %timediff = (%mini.EZM_SuddenDeathTimeLimit*60) - %mini.EZM_SuddenDeathTimer;
      if(%timediff == 3600) %mini.messageAll(0,"\c3You have \c2one hour\c3 left for this wave!");
//      else if(%timediff == 1800) %mini.messageAll(0,"\c3You have \c230 minutes\c3 left for this wave!");
//      else if(%timediff == 900) %mini.messageAll(0,"\c3You have \c215 minutes\c3 left for this wave!");
      else if(%timediff == 600) %mini.messageAll(0,"\c3You have \c210 minutes\c3 left for this wave!");
      else if(%timediff == 300) %mini.messageAll(0,"\c3You have \c25 minutes\c3 left for this wave!");
//      else if(%timediff == 120) %mini.messageAll(0,"\c3You have \c22 minutes\c3 left for this wave!");
      else if(%timediff == 60) %mini.messageAll(0,"\c3You have \c21 minute\c3 left for this wave!");
      if(%timediff == 30) %mini.messageAll(0,"\c3You have \c230 seconds\c3 left until sudden death!");
      else if(%timediff == 15) %mini.messageAll(0,"\c3You have \c215 seconds\c3 left until sudden death!");
      if(%timediff == 0)
      {
        if(%mini.EZM_SuddenDeath == 0)
        {
          %mini.messageAll(0,"\c0SUDDEN DEATH! ALL YOUR HEALTH HAS BEEN REDUCED TO 1!");
          for(%i=0;%i<%mini.numMembers;%i++)
            %mini.member[%i].player.setDamageLevel(%mini.member[%i].player.dataBlock.maxDamage - 1);
          for(%i=0;%i<EZMZombies.getCount();%i++)
            EZMZombies.getObject(%i).setDamageLevel(EZMZombies.getObject(%i).dataBlock.maxDamage - 1);
        }
        else if(%mini.EZM_SuddenDeath == 1)
        {
          %mini.messageAll(0,"\c0SUDDEN DEATH! ALL YOUR SOULS HAVE BEEN SENT TO HELL!");
          for(%i=0;%i<%mini.numMembers;%i++)
          {
            %mini.member[%i].setDead(1);
            %mini.member[%i].setLives(0);
            %mini.member[%i].player.kill();
          }
        }
        else if(%mini.EZM_SuddenDeath == 2)
        {
          %mini.messageAll(0,"\c0SUDDEN DEATH! ALL CREATURES HAVE BEEN SENT BACK TO HELL!");
//          for(%i=0;%i<EZMZombies.getCount();%i++)
//            EZMZombies.getObject(%i).kill();
          while(EZMZombies.getCount() > 0) EZMZombies.getObject(0).kill();
        }
      }
      %mini.EZM_SuddenDeathTimer += 1;
    }
  }
}

function Slayer_EZM_SpawnWave(%mini)
{
  if(!isObject(%mini)) return;
  for(%i=0;%i<5;%i++)
  {
    if(%mini.EZM_ZombieCount >= %mini.EZM_ZombieAmountMaxSpawned) break;
    if(%mini.EZM_ZombieWaveCount < 1) break;
    %brick = EZMZombieSpawns.getObject(getRandom(EZMZombieSpawns.getCount()-1));
    EZM_SpawnZombie(%brick,%mini);
  }
}

function Slayer_EZM_SpawnBoss(%mini)
{
  if(!isObject(%mini)) return;
  if(%mini.EZM_ZombieCount >= %mini.EZM_ZombieAmountMaxSpawned) return;
  if(%mini.EZM_BossCount < 1) return;
  %brick = EZMZombieSpawns.getObject(getRandom(EZMZombieSpawns.getCount()-1));
  EZM_SpawnBoss(%brick,%mini);
}

function Slayer_EZM_UpdateBossHealth(%mini)
{
  %damage = %count = 0;
  for(%i=0;%i<EZMZombies.getCount();%i++)
  {
    %a = EZMZombies.getObject(%i);
    if(%a.EZMisBoss)
    {
      %damage += 1.0 - %a.getDamagePercent();
      %count += 1;
    }
  }
  if(%damage > 0) { for(%i=0;%i<%mini.numMembers;%i++) bottomPrint(%mini.member[%i],"<color:ffff00>Boss Health:" SPC mCeil(%damage*100) @ "% (" @ %count @ " Bosses)",2); }
}
