//########## Bow

datablock ProjectileData(EZM_BowProjectile : arrowProjectile)
{
  uiName = "";
  directDamage = 15;
  muzzleVelocity = 100;
  impactImpulse = 100;
  verticalImpulse = 100;
};

datablock ShapeBaseImageData(EZM_BowImage : BowImage)
{
  projectile = EZM_BowProjectile;
  projectileType = Projectile;
  colorShiftColor = "0.3 0.4 0.2 1";

  stateName[0]                     = "Activate";
  stateTimeoutValue[0]             = 0.5;
  stateTransitionOnTimeout[0]       = "Ready";
  stateSound[0]					= weaponSwitchSound;

  stateName[1]                     = "Ready";
  stateTransitionOnTriggerDown[1]  = "Fire";
  stateAllowImageChange[1]         = true;

  stateName[2]                    = "Fire";
  stateTransitionOnTimeout[2]     = "Reload";
  stateTimeoutValue[2]            = 0.05;
  stateFire[2]                    = true;
  stateAllowImageChange[2]        = false;
  stateSequence[2]                = "Fire";
  stateScript[2]                  = "onFire";
  stateWaitForTimeout[2]			= true;
  stateSound[2]					= bowFireSound;

  stateName[3]			= "Reload";
  stateSequence[3]                = "Reload";
  stateAllowImageChange[3]        = false;
  stateTimeoutValue[3]            = 0.5;
  stateWaitForTimeout[3]		= true;
  stateTransitionOnTimeout[3]     = "Check";

  stateName[4]			= "Check";
  stateTransitionOnTriggerUp[4]	= "StopFire";
  stateTransitionOnTriggerDown[4]	= "Fire";

  stateName[5]                    = "StopFire";
  stateTransitionOnTimeout[5]     = "Ready";
  stateTimeoutValue[5]            = 0.2;
  stateAllowImageChange[5]        = false;
  stateWaitForTimeout[5]		= true;
  stateScript[5]                  = "onStopFire";
};

function EZM_BowImage::onFire(%this,%obj,%slot)
{
  %scale = getWord(%obj.getScale(),2);
  %spread = 0.004;
  %x = (getRandom() - 0.5) * 10 * 3.141 * %spread;
  %y = (getRandom() - 0.5) * 10 * 3.141 * %spread;
  %z = (getRandom() - 0.5) * 10 * 3.141 * %spread;
  %p = new Projectile()
  {
    dataBlock = %this.projectile;
    initialVelocity = MatrixMulVector(MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z),VectorScale(%obj.getMuzzleVector(%slot),%this.projectile.muzzleVelocity * %scale));
    initialPosition = %obj.getMuzzlePoint(%slot);
    sourceObject = %obj;
    sourceSlot = 0;
    client = %obj.client;
  };
  MissionCleanup.add(%p);
  %p.setScale(%scale SPC %scale SPC %scale);
}
