//########## Items

//### Sounds

datablock AudioProfile(EZM_DynamiteFuzeSound)
{
  filename = "./dynamitefuze.wav";
  description = AudioClosestLooping3d;
  preload = true;
};

//### Effects

datablock ParticleData(EZM_DynamiteFuzeParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = 1;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/star1";
  colors[0] = "1 0.6 0.2 0.5";
  colors[1] = "1 0.5 0 0.5";
  colors[2] = "1 0 0 0";
  sizes[0] = 0.5;
  sizes[1] = 0.2;
  sizes[2] = 0;
  times[0] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(EZM_DynamiteFuzeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 2;
  periodVarianceMS = 0;
  ejectionVelocity = 5;
  velocityVariance = 3;
  ejectionOffset = 0.5;
  thetaMin = 0;
  thetaMax = 15;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "EZM_DynamiteFuzeParticle";
};

datablock ExplosionData(EZM_DynamiteExplosion : TankShellExplosion)
{
  explosionShape = "";
  damageRadius = 8;
  radiusDamage = 80;
  impulseRadius = 12;
  impulseForce = 250;
};

//### Projectiles

AddDamageType("EZM_Dynamite",'<bitmap:Add-Ons/Gamemode_EndlessZombies/items/CI_dynamite> %1','%2 <bitmap:Add-Ons/Gamemode_EndlessZombies/items/CI_dynamite> %1',1,1);

datablock ProjectileData(EZM_DynamiteInstantProjectile)
{
  uiName = "";
  directDamage = 0;
  directDamageType = $DamageType::EZM_Dynamite;
  radiusDamageType = $DamageType::EZM_Dynamite;
  explosion = EZM_DynamiteExplosion;
  explodeOnDeath = true;
  muzzleVelocity = 0;
  armingDelay = 50;
  lifetime = 50;
  fadeDelay = 50;
};

datablock ProjectileData(EZM_DynamiteProjectile)
{
  uiName = "";
  projectileShapeName = "./dynamite_projectile.dts";
  directDamage = 0;
  directDamageType = $DamageType::EZM_Dynamite;
  radiusDamageType = $DamageType::EZM_Dynamite;
  brickExplosionRadius = 6;
  brickExplosionImpact = true;
  brickExplosionForce = 20;
  brickExplosionMaxVolume = 20;
  brickExplosionMaxVolumeFloating = 20;
  explosion = EZM_DynamiteExplosion;
  explodeOnDeath = true;
  explodeOnPlayerImpact = true;
  particleEmitter = EZM_DynamiteFuzeEmitter;
  muzzleVelocity = 30;
  verInheritFactor = 1;
  armingDelay = 3000;
  lifetime = 3000;
  fadeDelay = 3000;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
  isBallistic = true;
  gravityMod = 1;
};

//### Images

datablock ShapeBaseImageData(EZM_DynamiteInstantImage)
{
  shapeFile = "./dynamite.dts";
  emap = true;
  mountPoint = 0;
  correctMuzzleVector = false;
  className = "WeaponImage";
  item = BowItem;
  ammo = "";
  projectile = EZM_DynamiteInstantProjectile;
  projectileType = Projectile;
  melee = true;
  doRetraction = false;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.2;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "Fire";
  stateAllowImageChange[1] = true;
  stateSound[1] = EZM_DynamiteFuzeSound;
  stateEmitter[1] = EZM_DynamiteFuzeEmitter;
  stateEmitterTime[1] = 10;
  stateEmitterNode[1] = "fuze";
  stateTimeoutValue[1] = 10;
  stateTransitionOnTimeout[1] = "Ready";
  stateWaitForTimeout[1] = false;

  stateName[2] = "Fire";
  stateTransitionOnTimeout[2] = "Ready";
  stateTimeoutValue[2] = 1;
  stateFire[2] = true;
  stateAllowImageChange[2] = false;
  stateScript[2] = "onFire";
  stateWaitForTimeout[2] = true;
};

function EZM_DynamiteInstantImage::onFire(%this,%obj,%slot) { parent::onFire(%this,%obj,%slot); %obj.unMountImage(0); %obj.kill(); }

datablock ShapeBaseImageData(EZM_DynamiteImage)
{
  shapeFile = "./dynamite.dts";
  emap = true;
  mountPoint = 0;
  correctMuzzleVector = false;
  className = "WeaponImage";
  item = BowItem;
  ammo = "";
  projectile = EZM_DynamiteProjectile;
  projectileType = Projectile;
  melee = true;
  doRetraction = false;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.2;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "Fire";
  stateAllowImageChange[1] = true;
  stateSound[1] = EZM_DynamiteFuzeSound;
  stateEmitter[1] = EZM_DynamiteFuzeEmitter;
  stateEmitterTime[1] = 10;
  stateEmitterNode[1] = "fuze";
  stateTimeoutValue[1] = 10;
  stateTransitionOnTimeout[1] = "Ready";
  stateWaitForTimeout[1] = false;

  stateName[2] = "Fire";
  stateTransitionOnTimeout[2] = "Ready";
  stateTimeoutValue[2] = 3;
  stateFire[2] = true;
  stateAllowImageChange[2] = false;
  stateScript[2] = "onFire";
  stateWaitForTimeout[2] = true;
};
