//########## Gun

datablock ProjectileData(EZM_GunProjectile : gunProjectile)
{
  uiName = "";
  directDamage = 15;
  muzzleVelocity = 100;
  impactImpulse = 100;
  verticalImpulse = 100;
};

datablock ShapeBaseImageData(EZM_GunImage : GunImage)
{
  projectile = EZM_GunProjectile;
  projectileType = Projectile;
  colorShiftColor = "0.1 0.2 0.1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.15;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "Fire";
  stateAllowImageChange[1] = true;
  stateSequence[1] = "Ready";

  stateName[2] = "Fire";
  stateTransitionOnTimeout[2] = "Smoke";
  stateTimeoutValue[2] = 0.14;
  stateFire[2] = true;
  stateAllowImageChange[2] = false;
  stateSequence[2] = "Fire";
  stateScript[2] = "onFire";
  stateWaitForTimeout[2] = true;
  stateEmitter[2] = gunFlashEmitter;
  stateEmitterTime[2] = 0.05;
  stateEmitterNode[2] = "muzzleNode";
  stateSound[2] = gunShot1Sound;
  stateEjectShell[2]  = true;

  stateName[3] = "Smoke";
  stateEmitter[3] = gunSmokeEmitter;
  stateEmitterTime[3] = 0.05;
  stateEmitterNode[3] = "muzzleNode";
  stateTimeoutValue[3] = 0.01;
  stateTransitionOnTimeout[3] = "Reload";

  stateName[4] = "Reload";
  stateSequence[4] = "Reload";
  stateTransitionOnTriggerUp[4] = "Ready";
  stateSequence[4] = "Ready";
};

function EZM_GunImage::onFire(%this,%obj,%slot)
{
  if(%obj.getDamagePercent() < 1) %obj.playThread(2,shiftAway);
  %scale = getWord(%obj.getScale(),2);
  %spread = 0.004;
  %x = (getRandom() - 0.5) * 10 * 3.141 * %spread;
  %y = (getRandom() - 0.5) * 10 * 3.141 * %spread;
  %z = (getRandom() - 0.5) * 10 * 3.141 * %spread;
  %p = new Projectile()
  {
    dataBlock = %this.projectile;
    initialVelocity = MatrixMulVector(MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z),VectorScale(%obj.getMuzzleVector(%slot),%this.projectile.muzzleVelocity * %scale));
    initialPosition = %obj.getMuzzlePoint(%slot);
    sourceObject = %obj;
    sourceSlot = 0;
    client = %obj.client;
  };
  MissionCleanup.add(%p);
  %p.setScale(%scale SPC %scale SPC %scale);
}
