//########## Akimbo Guns

datablock ProjectileData(EZM_AkimboGunProjectile : AkimboGunProjectile)
{
  uiName = "";
  directDamage = 10;
  muzzleVelocity = 100;
  impactImpulse = 100;
  verticalImpulse = 100;
};

datablock ShapeBaseImageData(EZM_AkimboGunImage : AkimboGunImage)
{
  projectile = EZM_AkimboGunProjectile;
  projectileType = Projectile;
  colorShiftColor = "0.1 0.2 0.1 1";

  stateName[0] = "Activate";
  stateTransitionOnTimeout[0] = "Ready";
  stateTimeoutValue[0] = 0.2;
  stateSequence[0] = "ready";

  stateName[1] = "Ready";
  stateSequence[1] = "ready";
  stateTransitionOnTriggerDown[1] = "Fire";

  stateName[2] = "Fire";
  stateEjectShell[2]       = true;
  stateSequence[2] = "Fire";
  stateTransitionOnTimeout[2] = "Smoke";
  stateWaitForTimeout[2] = true;
  stateTimeoutValue[2] = 0.09;
  stateFire[2] = true;
  stateAllowImageChange[2] = false;
  stateScript[2] = "onFire";
  stateSound[2] = gunShot1Sound;
  stateEmitter[2] = gunFlashEmitter;
  stateEmitterTime[2] = 0.05;
  stateEmitterNode[2] = "muzzleNode";

  stateName[3] = "Smoke";
  stateEmitter[3] = gunSmokeEmitter;
  stateEmitterTime[3] = 0.05;
  stateEmitterNode[3] = "muzzleNode";
  stateTimeoutValue[3] = 0.01;
  stateTransitionOnTimeout[3] = "Reload";

  stateName[4] = "Reload";
  stateAllowImageChange[4] = false;
  stateTransitionOnTriggerUp[4] = "FireAkimbo";
  stateSequence[4] = "ready";

  stateName[5] = "FireAkimbo";
  stateTimeoutValue[5] = 0.09;
  stateScript[5] = "onFireAkimbo";
  stateTransitionOnTimeOut[5] = "ready";
};

function EZM_AkimboGunImage::onFireAkimbo(%this,%obj,%slot) { %obj.setImageTrigger(1,1); }

datablock ShapeBaseImageData(EZM_LeftHandedGunImage)
{
  projectile = EZM_AkimboGunProjectile;
  projectileType = Projectile;
  colorShiftColor = "0.1 0.2 0.1 1";

  stateName[0] = "Activate";
  stateTransitionOnTimeout[0] = "Ready";
  stateTimeoutValue[0] = 0.2;
  stateSequence[0] = "ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateSequence[1] = "ready";
  stateTransitionOnTriggerDown[1] = "Fire";

  stateName[2] = "Fire";
  stateEjectShell[2]       = true;
  stateSequence[2] = "Fire";
  stateTransitionOnTimeout[2] = "Smoke";
  stateWaitForTimeout[2] = true;
  stateTimeoutValue[2] = 0.09;
  stateFire[2] = true;
  stateAllowImageChange[2] = false;
  stateScript[2] = "onFire";
  stateSound[2] = gunShot1Sound;
  stateEmitter[2] = gunFlashEmitter;
  stateEmitterTime[2] = 0.05;
  stateEmitterNode[2] = "muzzleNode";

  stateName[3] = "Smoke";
  stateEmitter[3] = gunSmokeEmitter;
  stateEmitterTime[3] = 0.05;
  stateEmitterNode[3] = "muzzleNode";
  stateTimeoutValue[3] = 0.01;
  stateTransitionOnTimeout[3] = "Reload";

  stateName[4] = "Reload";
  stateAllowImageChange[4] = false;
  stateTransitionOnTriggerUp[4] = "Ready";
  stateSequence[4] = "ready";
};

function EZM_LeftHandedGunImage::onFire(%this,%obj,%slot)
{
  if(%obj.getDamagePercent() < 1) %obj.playThread(2,leftrecoil);
  %scale = getWord(%obj.getScale(),2);
  %spread = 0.005;
  %x = (getRandom() - 0.5) * 10 * 3.141 * %spread;
  %y = (getRandom() - 0.5) * 10 * 3.141 * %spread;
  %z = (getRandom() - 0.5) * 10 * 3.141 * %spread;
  %p = new Projectile()
  {
    dataBlock = %this.projectile;
    initialVelocity = MatrixMulVector(MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z),VectorScale(%obj.getMuzzleVector(%slot),%this.projectile.muzzleVelocity * %scale));
    initialPosition = %obj.getMuzzlePoint(%slot);
    sourceObject = %obj;
    sourceSlot = 0;
    client = %obj.client;
  };
  MissionCleanup.add(%p);
  %p.setScale(%scale SPC %scale SPC %scale);
}

function EZM_AkimboGunImage::onMount(%this,%obj,%slot)
{
  parent::onMount(%this,%obj,%slot);
  %obj.mountImage(EZM_LeftHandedGunImage,1);
}

function EZM_AkimboGunImage::onUnMount(%this,%obj,%slot)
{
  parent::onUnMount(%this,%obj,%slot);
  %obj.unMountImage(1);
}

function EZM_LeftHandedGunImage::onMount(%this,%obj,%slot)
{
  parent::onMount(%this,%obj,%slot);
  %obj.playThread(1,armreadyboth);
}

function EZM_AkimboGunImage::onFire(%this,%obj,%slot)
{
  if(%obj.getDamagePercent() < 1) %obj.playThread(2,shiftAway);
  %scale = getWord(%obj.getScale(),2);
  %spread = 0.005;
  %x = (getRandom() - 0.5) * 10 * 3.141 * %spread;
  %y = (getRandom() - 0.5) * 10 * 3.141 * %spread;
  %z = (getRandom() - 0.5) * 10 * 3.141 * %spread;
  %p = new Projectile()
  {
    dataBlock = %this.projectile;
    initialVelocity = MatrixMulVector(MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z),VectorScale(%obj.getMuzzleVector(%slot),%this.projectile.muzzleVelocity * %scale));
    initialPosition = %obj.getMuzzlePoint(%slot);
    sourceObject = %obj;
    sourceSlot = 0;
    client = %obj.client;
  };
  MissionCleanup.add(%p);
  %p.setScale(%scale SPC %scale SPC %scale);
}
