//########## Items

//### Sounds

datablock AudioProfile(gc_SwingSound)
{
  filename = "./swing.wav";
  description = AudioClosest3d;
  preload = true;
};

//### Effects

datablock ParticleData(EZM_ShurikenTrailParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/cloud";
  colors[0] = "1 1 1 0.2";
  colors[1] = "1 1 1 0";
  sizes[0] = 0.5;
  sizes[1] = 0;
  useInvAlpha = false;
};

datablock ParticleEmitterData(EZM_ShurikenTrailEmitter)
{
  uiName = "";
  ejectionPeriodMS = 2;
  periodVarianceMS = 0;
  ejectionVelocity = 0;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "EZM_ShurikenTrailParticle";
};

//### Projectiles

AddDamageType("EZM_Shovel",'<bitmap:Add-Ons/Gamemode_EndlessZombies/items/CI_shovel> %1','%2 <bitmap:Add-Ons/Gamemode_EndlessZombies/items/CI_shovel> %1',1,1);

datablock ProjectileData(EZM_ShovelProjectile)
{
  uiName = "";
  directDamage = 10;
  directDamageType = $DamageType::EZM_Shovel;
  radiusDamageType = $DamageType::EZM_Shovel;
  explosion = swordExplosion;
  muzzleVelocity = 50;
  velInheritFactor = 1;
  armingDelay = 0;
  lifetime = 100;
  fadeDelay = 70;
  bounceElasticity = 0;
  bounceFriction = 0;
};

AddDamageType("EZM_Pickaxe",'<bitmap:Add-Ons/Gamemode_EndlessZombies/items/CI_pickaxe> %1','%2 <bitmap:Add-Ons/Gamemode_EndlessZombies/items/CI_pickaxe> %1',1,1);

datablock ProjectileData(EZM_PickaxeProjectile)
{
  uiName = "";
  directDamage = 15;
  directDamageType = $DamageType::EZM_Pickaxe;
  radiusDamageType = $DamageType::EZM_Pickaxe;
  explosion = swordExplosion;
  muzzleVelocity = 50;
  velInheritFactor = 1;
  armingDelay = 0;
  lifetime = 100;
  fadeDelay = 70;
  bounceElasticity = 0;
  bounceFriction = 0;
};

AddDamageType("EZM_FryingPan",'<bitmap:Add-Ons/Gamemode_EndlessZombies/items/CI_fryingpan> %1','%2 <bitmap:Add-Ons/Gamemode_EndlessZombies/items/CI_fryingpan> %1',1,1);

datablock ProjectileData(EZM_FryingPanProjectile)
{
  uiName = "";
  directDamage = 20;
  directDamageType = $DamageType::EZM_FryingPan;
  radiusDamageType = $DamageType::EZM_FryingPan;
  explosion = swordExplosion;
  muzzleVelocity = 50;
  velInheritFactor = 1;
  armingDelay = 0;
  lifetime = 100;
  fadeDelay = 70;
  bounceElasticity = 0;
  bounceFriction = 0;
};

AddDamageType("EZM_ButcherKnife",'<bitmap:Add-Ons/Gamemode_EndlessZombies/items/CI_butcherknife> %1','%2 <bitmap:Add-Ons/Gamemode_EndlessZombies/items/CI_butcherknife> %1',1,1);

datablock ProjectileData(EZM_ButcherKnifeProjectile)
{
  uiName = "";
  directDamage = 25;
  directDamageType = $DamageType::EZM_ButcherKnife;
  radiusDamageType = $DamageType::EZM_ButcherKnife;
  explosion = swordExplosion;
  muzzleVelocity = 50;
  velInheritFactor = 1;
  armingDelay = 0;
  lifetime = 100;
  fadeDelay = 70;
  bounceElasticity = 0;
  bounceFriction = 0;
};

AddDamageType("EZM_Shuriken",'<bitmap:Add-Ons/Gamemode_EndlessZombies/items/CI_shuriken> %1','%2 <bitmap:Add-Ons/Gamemode_EndlessZombies/items/CI_shuriken> %1',1,1);

datablock ProjectileData(EZM_ShurikenProjectile)
{
  uiName = "";
  projectileShapeName = "./shuriken_projectile.dts";
  directDamage = 15;
  directDamageType = $DamageType::EZM_Shuriken;
  radiusDamageType = $DamageType::EZM_Shuriken;
  explosion = swordExplosion;
  explodeOnPlayerImpact = true;
  explodeOnDeath = true;
  particleEmitter = EZM_ShurikenTrailEmitter;
  muzzleVelocity = 30;
  velInheritFactor = 1;
  armingDelay = 3000;
  lifetime = 3000;
  fadeDelay = 3000;
  isBallistic = true;
  bounceElasticity = 0.9;
  bounceFriction = 0;
  gravityMod = 0;
};

//### Items

//datablock ItemData(EZM_ShovelItem)
//{
//  uiName = "Shovel";
//  category = "Weapon";
//  className = "Weapon";
//  shapeFile = "./shovel.dts";
//  mass = 1;
//  density = 0.2;
//  elasticity = 0.2;
//  friction = 0.6;
//  iconName = "./icon_shovel";
//  doColorShift = true;
//  colorShiftColor = "1 1 1 1";
//  image = EZM_ShovelImage;
//  canDrop = true;
//};

//datablock ItemData(EZM_PickaxeItem)
//{
//  uiName = "Pickaxe";
//  category = "Weapon";
//  className = "Weapon";
//  shapeFile = "./pickaxe.dts";
//  mass = 1;
//  density = 0.2;
//  elasticity = 0.2;
//  friction = 0.6;
//  iconName = "./icon_pickaxe";
//  doColorShift = true;
//  colorShiftColor = "1 1 1 1";
//  image = EZM_PickaxeImage;
//  canDrop = true;
//};

//datablock ItemData(EZM_FryingPanItem)
//{
//  uiName = "Frying Pan";
//  category = "Weapon";
//  className = "Weapon";
//  shapeFile = "./fryingpan.dts";
//  mass = 1;
//  density = 0.2;
//  elasticity = 0.2;
//  friction = 0.6;
//  iconName = "./icon_fryingpan";
//  doColorShift = true;
//  colorShiftColor = "1 1 1 1";
//  image = EZM_FryingPanImage;
//  canDrop = true;
//};

//datablock ItemData(EZM_ButcherKnifeItem)
//{
//  uiName = "ButcherKnife";
//  category = "Weapon";
//  className = "Weapon";
//  shapeFile = "./butcherknife.dts";
//  mass = 1;
//  density = 0.2;
//  elasticity = 0.2;
//  friction = 0.6;
//  iconName = "./icon_butcherknife";
//  doColorShift = true;
//  colorShiftColor = "1 1 1 1";
//  image = EZM_ButcherKnifeImage;
//  canDrop = true;
//};

//datablock ItemData(EZM_ShurikenItem)
//{
//  uiName = "Shuriken";
//  category = "Weapon";
//  className = "Weapon";
//  shapeFile = "./shuriken.dts";
//  mass = 1;
//  density = 0.2;
//  elasticity = 0.2;
//  friction = 0.6;
//  iconName = "./icon_shuriken";
//  doColorShift = true;
//  colorShiftColor = "1 1 1 1";
//  image = EZM_ShurikenImage;
//  canDrop = true;
//};

//### Images

datablock ShapeBaseImageData(EZM_ShovelImage)
{
  shapeFile = "./shovel.dts";
  emap = true;
  mountPoint = 0;
  correctMuzzleVector = false;
  className = "WeaponImage";
  item = EZM_ShovelItem;
  ammo = "";
  projectile = EZM_ShovelProjectile;
  projectileType = Projectile;
  melee = true;
  doRetraction = false;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.2;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "PreFire";
  stateAllowImageChange[1] = true;

  stateName[2] = "PreFire";
  stateScript[2] = "onPreFire";
  stateAllowImageChange[2] = false;
  stateTimeoutValue[2] = 0.1;
  stateTransitionOnTimeout[2] = "Fire";

  stateName[3] = "Fire";
  stateTransitionOnTimeout[3] = "CheckFire";
  stateTimeoutValue[3] = 0.2;
  stateFire[3] = true;
  stateAllowImageChange[3] = false;
  stateSequence[3] = "Fire";
  stateScript[3] = "onFire";
  stateWaitForTimeout[3] = true;
  stateSound[3] = gc_SwingSound;

  stateName[4] = "CheckFire";
  stateTransitionOnTriggerUp[4] = "StopFire";
  stateTransitionOnTriggerDown[4] = "Fire";

  stateName[5] = "StopFire";
  stateTransitionOnTimeout[5] = "Ready";
  stateTimeoutValue[5] = 0.2;
  stateAllowImageChange[5] = false;
  stateWaitForTimeout[5] = true;
  stateSequence[5] = "StopFire";
  stateScript[5] = "onStopFire";
};

function EZM_ShovelImage::onPreFire(%this,%obj,%slot) { %obj.playthread(2,armattack); }
function EZM_ShovelImage::onStopFire(%this,%obj,%slot) { %obj.playthread(2,root); }

datablock ShapeBaseImageData(EZM_PickaxeImage)
{
  shapeFile = "./pickaxe.dts";
  emap = true;
  mountPoint = 0;
  correctMuzzleVector = false;
  className = "WeaponImage";
  item = EZM_PickaxeItem;
  ammo = "";
  projectile = EZM_PickaxeProjectile;
  projectileType = Projectile;
  melee = true;
  doRetraction = false;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.2;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "PreFire";
  stateAllowImageChange[1] = true;

  stateName[2] = "PreFire";
  stateScript[2] = "onPreFire";
  stateAllowImageChange[2] = false;
  stateTimeoutValue[2] = 0.1;
  stateTransitionOnTimeout[2] = "Fire";

  stateName[3] = "Fire";
  stateTransitionOnTimeout[3] = "CheckFire";
  stateTimeoutValue[3] = 0.2;
  stateFire[3] = true;
  stateAllowImageChange[3] = false;
  stateSequence[3] = "Fire";
  stateScript[3] = "onFire";
  stateWaitForTimeout[3] = true;
  stateSound[3] = gc_SwingSound;

  stateName[4] = "CheckFire";
  stateTransitionOnTriggerUp[4] = "StopFire";
  stateTransitionOnTriggerDown[4] = "Fire";

  stateName[5] = "StopFire";
  stateTransitionOnTimeout[5] = "Ready";
  stateTimeoutValue[5] = 0.2;
  stateAllowImageChange[5] = false;
  stateWaitForTimeout[5] = true;
  stateSequence[5] = "StopFire";
  stateScript[5] = "onStopFire";
};

function EZM_PickaxeImage::onPreFire(%this,%obj,%slot) { %obj.playthread(2,armattack); }
function EZM_PickaxeImage::onStopFire(%this,%obj,%slot) { %obj.playthread(2,root); }

datablock ShapeBaseImageData(EZM_FryingPanImage)
{
  shapeFile = "./fryingpan.dts";
  emap = true;
  mountPoint = 0;
  correctMuzzleVector = false;
  className = "WeaponImage";
  item = EZM_FryingPanItem;
  ammo = "";
  projectile = EZM_FryingPanProjectile;
  projectileType = Projectile;
  melee = true;
  doRetraction = false;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.2;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "PreFire";
  stateAllowImageChange[1] = true;

  stateName[2] = "PreFire";
  stateScript[2] = "onPreFire";
  stateAllowImageChange[2] = false;
  stateTimeoutValue[2] = 0.1;
  stateTransitionOnTimeout[2] = "Fire";

  stateName[3] = "Fire";
  stateTransitionOnTimeout[3] = "CheckFire";
  stateTimeoutValue[3] = 0.2;
  stateFire[3] = true;
  stateAllowImageChange[3] = false;
  stateSequence[3] = "Fire";
  stateScript[3] = "onFire";
  stateWaitForTimeout[3] = true;
  stateSound[3] = gc_SwingSound;

  stateName[4] = "CheckFire";
  stateTransitionOnTriggerUp[4] = "StopFire";
  stateTransitionOnTriggerDown[4] = "Fire";

  stateName[5] = "StopFire";
  stateTransitionOnTimeout[5] = "Ready";
  stateTimeoutValue[5] = 0.2;
  stateAllowImageChange[5] = false;
  stateWaitForTimeout[5] = true;
  stateSequence[5] = "StopFire";
  stateScript[5] = "onStopFire";
};

function EZM_FryingPanImage::onPreFire(%this,%obj,%slot) { %obj.playthread(2,armattack); }
function EZM_FryingPanImage::onStopFire(%this,%obj,%slot) { %obj.playthread(2,root); }

datablock ShapeBaseImageData(EZM_ButcherKnifeImage)
{
  shapeFile = "./butcherknife.dts";
  emap = true;
  mountPoint = 0;
  correctMuzzleVector = false;
  className = "WeaponImage";
  item = EZM_ButcherKnifeItem;
  ammo = "";
  projectile = EZM_ButcherKnifeProjectile;
  projectileType = Projectile;
  melee = true;
  doRetraction = false;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.2;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "PreFire";
  stateAllowImageChange[1] = true;

  stateName[2] = "PreFire";
  stateScript[2] = "onPreFire";
  stateAllowImageChange[2] = false;
  stateTimeoutValue[2] = 0.1;
  stateTransitionOnTimeout[2] = "Fire";

  stateName[3] = "Fire";
  stateTransitionOnTimeout[3] = "CheckFire";
  stateTimeoutValue[3] = 0.2;
  stateFire[3] = true;
  stateAllowImageChange[3] = false;
  stateSequence[3] = "Fire";
  stateScript[3] = "onFire";
  stateWaitForTimeout[3] = true;
  stateSound[3] = gc_SwingSound;

  stateName[4] = "CheckFire";
  stateTransitionOnTriggerUp[4] = "StopFire";
  stateTransitionOnTriggerDown[4] = "Fire";

  stateName[5] = "StopFire";
  stateTransitionOnTimeout[5] = "Ready";
  stateTimeoutValue[5] = 0.2;
  stateAllowImageChange[5] = false;
  stateWaitForTimeout[5] = true;
  stateSequence[5] = "StopFire";
  stateScript[5] = "onStopFire";
};

function EZM_ButcherKnifeImage::onPreFire(%this,%obj,%slot) { %obj.playthread(2,armattack); }
function EZM_ButcherKnifeImage::onStopFire(%this,%obj,%slot) { %obj.playthread(2,root); }

datablock ShapeBaseImageData(EZM_ShurikenImage)
{
  shapeFile = "./shuriken.dts";
  emap = true;
  mountPoint = 0;
  correctMuzzleVector = false;
  className = "WeaponImage";
  item = EZM_ShurikenItem;
  ammo = "";
  projectile = EZM_ShurikenProjectile;
  projectileType = Projectile;
  melee = true;
  doRetraction = false;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.01;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = swordDrawSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "Fire";
  stateAllowImageChange[1] = true;

  stateName[2] = "Fire";
  stateTransitionOnTriggerUp[2] = "Ready";
  stateTimeoutValue[2] = 1;
  stateFire[2] = true;
  stateAllowImageChange[2] = false;
  stateScript[2] = "onFire";
  stateWaitForTimeout[2] = true;
  stateSound[2] = gc_SwingSound;
};

function EZM_ShurikenImage::onFire(%this,%obj,%slot)
{
  %obj.playthread(2,activate);
  %scale = getWord(%obj.getScale(),2);
  %spread = 0.001;
  %x = (getRandom() - 0.5) * 10 * 3.141 * %spread;
  %y = (getRandom() - 0.5) * 10 * 3.141 * %spread;
  %z = (getRandom() - 0.5) * 10 * 3.141 * %spread;
  %p = new Projectile()
  {
    dataBlock = %this.projectile;
    initialVelocity = MatrixMulVector(MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z),VectorScale(%obj.getMuzzleVector(0),%this.projectile.muzzleVelocity * %scale));
    initialPosition = %obj.getMuzzlePoint(0);
    sourceObject = %obj;
    sourceSlot = 0;
    client = %obj.client;
  };
  MissionCleanup.add(%p);
  %p.setScale(%scale SPC %scale SPC %scale);
}
