//########## Kompressor Wand

//### Effects

datablock ParticleData(EZM_KompressorWandParticle)
{
  dragCoefficient = 0;
  inheritedVelFactor = 0;
  lifetimeMS = 500;
  textureName = "base/data/particles/thinRing";
  spinSpeed = 0;
  colors[0] = "0 0 0 1";
  colors[1] = "0.2 0 0.4 0.5";
  colors[2] = "0.5 0 1 0";
  sizes[0] = 0.1;
  sizes[1] = 0.3;
  sizes[2] = 0.2;
  times[0] = 0;
  times[1] = 0.25;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(EZM_KompressorWandEmitter)
{
  ejectionPeriodMS = 5;
  ejectionVelocity = 1;
  velocityVariance = 1;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  particles = "EZM_KompressorWandParticle";
  uiName = "";
};

datablock ParticleData(EZM_KompressorWandExplosionParticle)
{
  dragCoefficient = 0;
  inheritedVelFactor = 0;
  lifetimeMS = 1000;
  textureName = "base/data/particles/dot";
  spinSpeed = 0;
  colors[0] = "0 0 0 1";
  colors[1] = "0.1 0 0.2 1";
  colors[2] = "0.5 0 1 0";
  sizes[0] = 2;
  sizes[1] = 0.2;
  sizes[2] = 0.1;
  times[0] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(EZM_KompressorWandExplosionEmitter)
{
  ejectionPeriodMS = 2;
  ejectionVelocity = 5;
  velocityVariance = 3;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  particles = "EZM_KompressorWandExplosionParticle";
  uiName = "";
};

datablock ExplosionData(EZM_KompressorWandExplosion : AdminWandExplosion)
{
  uiName = "";
  particleEmitter = "";
  emitter[0] = EZM_KompressorWandExplosionEmitter;
  lifetimeMS = 100;
};

//### Projectile

datablock ProjectileData(EZM_KompressorWandProjectile)
{
  uiName = "";
  projectileShapeName = "";
  directDamage = 15;
  directDamageType = $DamageType::EZM_Wand;
  radiusDamageType = $DamageType::EZM_Wand;
  impactImpulse = 200;
  verticalImpulse = 200;
  particleEmitter = EZM_KompressorWandEmitter;
  explosion = EZM_KompressorWandExplosion;
  muzzleVelocity = 30;
  verInheritFactor = 0;
  lifetime = 5000;
  fadeDelay = 5000;
  armingDelay = 0;
};

datablock ShapeBaseImageData(EZM_KompressorWandImage : AdminWandImage)
{
  projectile = EZM_KompressorWandProjectile;
  projectileType = Projectile;
  colorShiftColor = "0.5 0 1 1";
};

function EZM_KompressorWandImage::onPreFire(%this,%obj,%slot) { %obj.playthread(2,armattack); }
function EZM_KompressorWandImage::onStopFire(%this,%obj,%slot) { %obj.playthread(2,root); }
