//########## Rocket Launcher

datablock ExplosionData(EZM_RocketExplosion : rocketExplosion)
{
   damageRadius = 3;
   radiusDamage = 25;
   impulseRadius = 6;
   impulseForce = 200;
};

datablock ProjectileData(EZM_RocketLauncherProjectile : rocketLauncherProjectile)
{
   uiName = "";
   directDamage = 0;
   directDamageType = $DamageType::RocketDirect;
   radiusDamageType = $DamageType::RocketRadius;
   impactImpulse = 100;
   verticalImpulse = 100;
   explosion = EZM_RocketExplosion;
};

datablock ShapeBaseImageData(EZM_RocketLauncherImage)
{
  shapeFile = "Add-Ons/Weapon_Rocket_Launcher/rocketLauncher.dts";
  emap = true;
  mountPoint = 0;
  offset = "0 0 0";
  eyeOffset = 0;
  rotation = eulerToMatrix("0 0 0");
  correctMuzzleVector = true;
  className = "WeaponImage";
  item = BowItem;
  ammo = "";
  projectile = EZM_RocketLauncherProjectile;
  projectileType = Projectile;
  melee = false;
  armReady = true;
  doColorShift = true;
  colorShiftColor = "0.8 0.2 0 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.1;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "Fire";
  stateAllowImageChange[1] = true;
  stateSequence[1] = "Ready";

  stateName[2] = "Fire";
  stateTransitionOnTimeout[2] = "Smoke";
  stateTimeoutValue[2] = 0.1;
  stateFire[2] = true;
  stateAllowImageChange[2] = false;
  stateSequence[2] = "Fire";
  stateScript[2] = "onFire";
  stateWaitForTimeout[2] = true;
  stateEmitter[2] = rocketLauncherFlashEmitter;
  stateEmitterTime[2] = 0.1;
  stateEmitterNode[2] = tailNode;
  stateSound[2] = rocketFireSound;
  stateSequence[2] = "Fire";

  stateName[3] = "Smoke";
  stateEmitter[3] = rocketLauncherSmokeEmitter;
  stateEmitterTime[3] = 0.1;
  stateEmitterNode[3] = "muzzleNode";
  stateTimeoutValue[3] = 0.1;
  stateSequence[3] = "TrigDown";
  stateTransitionOnTimeout[3] = "CoolDown";
  stateAllowImageChange[3] = false;
  stateWaitForTimeout[3] = true;

  stateName[4] = "CoolDown";
  stateTimeoutValue[4] = 2;
  stateTransitionOnTimeout[4] = "Ready";
  stateSequence[4] = "Ready";
  stateAllowImageChange[4] = false;
  stateWaitForTimeout[4] = true;
};
