//########## Package

package EZMPackage
{
  function Slayer_MinigameSO::victoryCheck_lives(%mini)
  {
    %parent = parent::victoryCheck_lives(%mini);
    if(%mini.mode $= "EZM" && %mini.isResetting == 0)
    {
      %playercount = %mini.numMembers;
      for(%i=0;%i<%mini.numMembers;%i++)
      {
        %player = %mini.member[%i];
        if(%player.getLives() < 1 && %player.Dead()) %playercount -= 1;
      }
      if(%playercount < 1)
      {
        for(%i=0;%i<%mini.numMembers;%i++)
        {
          %mini.member[%i].play2d("EZM_GameOversound");
        }
        return 0;
      }
      return -1;
    }
    return %parent;
  }
  function minigameCanDamage(%obj1,%obj2)
  {
    %mini1 = getMinigameFromObject(%obj1);
    %mini2 = getMinigameFromObject(%obj2);
    if(%mini1 $= %mini2)
    {
      if(%mini1.isEZM)
      {
        if(%obj1 == %obj2) return true;
        if(%obj1.EZMisZombie && %obj2.EZMisZombie) return false;
        if(!%obj1.EZMisZombie && !%obj2.EZMisZombie) return false;
      }
    }
    parent::minigameCanDamage(%obj1,%obj2);
  }
  function serverCmdPlantBrick(%client)
  {
    if(isObject(%client) && isObject(%client.player.tempBrick) && %client.player.tempBrick.getDatablock().getName() $= "EZM_BotSpawnData" && %client.isAdmin == false) return;
    parent::serverCmdPlantBrick(%client);
  }
  function fxDTSBrick::onPlant(%this,%client)
  {
    parent::onPlant(%this,%client);
    if(%this.getDataBlock().getName() $= "EZM_BotSpawnData")
    {
      EZMZombieSpawns.add(%this);
      %this.setRendering(0);
      %this.setColliding(0);
    }
  }
  function fxDTSBrick::onLoadPlant(%this)
  {
    parent::onLoadPlant(%this);
    if(%this.getDataBlock().getName() $= "EZM_BotSpawnData")
    {
      EZMZombieSpawns.add(%this);
      %this.setRendering(0);
      %this.setColliding(0);
    }
  }
  function fxDTSBrick::delete(%this)
  {
    if(isObject(%this.bot)) %this.bot.delete();
    if(isObject(%this) && %this.getDataBlock().getName() $= "EZM_BotSpawnData") EZMZombieSpawns.remove(%this);
    parent::delete(%this);
  }
  function fxDTSBrick::onRemove(%this)
  {
    if(isObject(%this.bot)) %this.bot.delete();
    if(isObject(%this) && %this.getDataBlock().getName() $= "EZM_BotSpawnData") EZMZombieSpawns.remove(%this);
    parent::onRemove(%this);
  }
  function Armor::setDamageLevel(%obj,%level)
  {
    %mini = getMinigameFromObject(%obj);
    if(isObject(%mini) && %mini.isEZM)
    {
      %timediff = (%mini.EZM_SuddenDeathTimeLimit*60) - %mini.EZM_SuddenDeathTimer;
      if(%timediff < 1 && %mini.EZM_SuddenDeath == 0)
      {
        %level = %obj.dataBlock.maxDamage - 1;
      }
    }
    parent::setDamageLevel(%obj,%level);
  }
  function Armor::Damage(%this,%obj,%sourceObject,%pos,%damage,%damageType)
  {
    %mini = getMinigameFromObject(%obj);
    if(isObject(%mini) && %mini.isEZM)
    {
      if(%damage < 0)
      {
        %timediff = (%mini.EZM_SuddenDeathTimeLimit*60) - %mini.EZM_SuddenDeathTimer;
        if(%timediff < 1 && %mini.EZM_SuddenDeath == 0)
        {
          %damage = 0;
        }
      }
      if(%obj.EZMisZombie)
      {
        if(%obj.EZMisBoss) {
          if(%mini.EZM_BossCountInc != 0)
          {
            %add = %mini.numMembers * 50;
            %damage = %damage / ((%mini.EZM_ZombieHealth + (%mini.EZM_ZombieHealthInc * %mini.EZM_Wave) + %add) / 100);
            %percent = %obj.dataBlock.maxDamage * ((%mini.EZM_ZombieHealth + (%mini.EZM_ZombieHealthInc * %mini.EZM_Wave) + %add) / 100);
            %percent /= 100;
          }
          else
          {
            %add = %mini.numMembers * 50;
            %damage = %damage / ((%mini.EZM_ZombieHealth + %add) / 100);
            %percent = %obj.dataBlock.maxDamage * ((%mini.EZM_ZombieHealth + %add) / 100);
            %percent /= 100;
          }
          %sourceObject.client.EZM_DealtBossDamage += %damage;
          if(%sourceObject.client.EZM_DealtBossDamage >= %percent) {
            %sourceObject.client.incScore(%mini.EZM_ZombieBossDamagePoints);
            %sourceObject.client.EZM_DealtBossDamage -= %percent; }
        }
        else
          %damage = %damage / ((%mini.EZM_ZombieHealth + (%mini.EZM_ZombieHealthInc * %mini.EZM_Wave)) / 100);
        if(%mini.EZM_ZombieHeadDmg)
          if(getWord(%pos,2) < getWord(%obj.getWorldBoxCenter(),2) - 3.3*getWord(%obj.getScale(),2))
            %damage = 0;
        if(isObject(%sourceObject.client))
          if(isObject(%source = %sourceObject.client.player))
//              if(isObject(%obj.getMoveObject()))
//                if(VectorDist(%obj,%source) < VectorDist(%obj,%obj.getMoveObject())*2)
//                  %obj.EZM_Chase(%source);
//              else
                %obj.EZM_Chase(%source);
      }
      if(%sourceObject.sourceObject.EZMisZombie)
      {
        %damagescaling = (%mini.EZM_DamageScaling + (%mini.EZM_DamageScalingInc * %mini.EZM_Wave)) / 100;
        %damage *= %damagescaling;
      }
    }
    parent::Damage(%this,%obj,%sourceObject,%pos,%damage,%damageType);
    if(%obj.EZMisBoss) Slayer_EZM_UpdateBossHealth(getMinigameFromObject(%obj));
  }
  function Armor::onDisabled(%this,%obj,%a,%b,%c,%d,%e,%f)
  {
    if(%obj.EZMisZombie)
    {
      %mini = getMinigameFromObject(%obj);
      if(isObject(%mini) && %mini.isEZM)
      {
        if(isObject(%obj.lastAttacker) && %obj != %obj.lastAttacker)
        {
//          if(%obj.dataBlock $= "EZM_ZombieSoldierPlayer") %score = %mini.EZM_ZombieSoldierKillPoints;
          if(1 == 2) %score = %mini.EZM_ZombieSoldierKillPoints;
          else if(%obj.EZMisBoss) %score = %mini.EZM_ZombieBossKillPoints;
          else
            %score = %mini.EZM_ZombieKillPoints;
          if(!isObject(%obj.lastAssistAttacker) || %obj.lastAttacker == %obj.lastAssistAttacker) %obj.lastAttacker.incScore(%score);
          else
          {
            %obj.lastAttacker.incScore(%score);
            %obj.lastAssistAttacker.incScore(%score);
          }
          if(%obj.EZMisBoss) {
            if(!isObject(%obj.lastAssistAttacker) || %obj.lastAttacker == %obj.lastAssistAttacker) %mini.messageAll(0,"\c2" @ %obj.lastAttacker.name @ " finished off " @ %obj.name @ "!");
          else
            %mini.messageAll(0,"\c2" @ %obj.lastAttacker.name @ " + " @ %obj.lastAssistAttacker.name @ " finished off " @ %obj.name @ "!"); }
        }
        EZMZombies.remove(%obj);
        %mini.EZM_ZombieCount -= 1;
        %count = %mini.EZM_ZombieCount + %mini.EZM_ZombieWaveCount;
        if(%count > 0)
        {
          if(%count == 1) %mini.messageAll(0,"\c3There is \c2one\c3 zombie left!");
          else if(%count == 5 || %count == 10 || %count == 20 || %count == 30 || %count == 40 || %count == 50 || %count == 75 || %count == 100 || %count == 150 || %count == 200) %mini.messageAll(0,"\c3There are \c2" @ %count @ "\c3 zombies left!");
        }
      }
    }
    parent::onDisabled(%this,%obj,%a,%b,%c,%d,%e,%f);
  }
  function WheeledVehicleData::onCollision(%this,%obj,%col,%a,%b)
  {
    if(%col.EZMisZombie) return;
    parent::onCollision(%this,%obj,%col,%a,%b);
  }
  function Armor::onCollision(%this,%obj,%col,%a,%b)
  {
    if(%obj.EZMisZombie && !%col.EZMisZombie) return;
    parent::onCollision(%this,%obj,%col,%a,%b);
  }
};
activatepackage(EZMPackage);
