//########## Zombie Data Stuff

function EZM_addZombie(%name,%namelist,%datablock,%playersize,%melee,%ranged,%specialwave,%propability,%allow)
{
  if(%name $= "") return;
  if(%datablock $= "") return;

  %i = 0;
  while($EZM_Zombies[%i,"Name"] !$= "") %i += 1;

  if(%namelist $= "" || %namelist $= 0) %namelist = %name;
  if(%melee $= "" || %melee $= 0) %melee = "EZM_SwordImage EZM_ShovelImage EZM_PickaxeImage EZM_FryingPanImage EZM_ButcherKnifeImage";
  if(%ranged $= "" || %ranged $= 0) %ranged = "EZM_BowImage EZM_GunImage EZM_AkimboGunImage";
  if(%propability < 1) %propability = 1;
  if(%allow $= "" || %allow $= 0) %allow = -1;
  if(%specialwave $= "" || %specialwave !$= 1) %specialwave = 0;

  $EZM_Zombies[%i,"Name"] = %name;
  $EZM_Zombies[%i,"Namelist"] = %namelist;
  $EZM_Zombies[%i,"Datablock"] = %datablock;
  $EZM_Zombies[%i,"PlayerSize"] = %playersize;
  $EZM_Zombies[%i,"Melee"] = %melee;
  $EZM_Zombies[%i,"Ranged"] = %ranged;
  $EZM_Zombies[%i,"SpecialWave"] = %specialwave;
  $EZM_Zombies[%i,"Propability"] = %propability;
  $EZM_Zombies[%i,"Allow"] = %allow;
}

function EZM_addBoss(%name,%namelist,%datablock,%playersize,%melee,%ranged,%propability,%allow)
{
  if(%name $= "") return;
  if(%datablock $= "") return;

  %i = 0;
  while($EZM_Bosses[%i,"Name"] !$= "") %i += 1;

  if(%namelist $= "" || %namelist $= 0) %namelist = %name;
  if(%melee $= "" || %melee $= 0) %melee = "EZM_RocketLauncherImage";
  if(%ranged $= "" || %ranged $= 0) %ranged = "EZM_RocketLauncherImage";
  if(%propability < 1) %propability = 1;
  if(%allow $= "" || %allow $= 0) %allow = -1;

  $EZM_Bosses[%i,"Name"] = %name;
  $EZM_Bosses[%i,"Namelist"] = %namelist;
  $EZM_Bosses[%i,"Datablock"] = %datablock;
  $EZM_Bosses[%i,"PlayerSize"] = %playersize;
  $EZM_Bosses[%i,"Melee"] = %melee;
  $EZM_Bosses[%i,"Ranged"] = %ranged;
  $EZM_Bosses[%i,"Propability"] = %propability;
  $EZM_Bosses[%i,"Allow"] = %allow;
}

function EZM_addAppearance(%name,%appearance,%hidenodes,%facedecal,%chestdecal,%mountedimage)
{
  if(%name $= "") return;

  %i = 0;
  while($EZM_ZombieAppearances[%name,%i,"Appearance"] !$= "") %i += 1;

  if(%appearance $= "" || %appearance $= 0) %appearance = -1;
  if(%hidenodes $= "" || %hidenodes $= 0) %hidenodes = -1;
  if(%facedecal $= "" || %facedecal $= 0) %facedecal = "Smiley";
  if(%chestdecal $= "" || %chestdecal $= 0) %chestdecal = "AAA-None";
  if(%mountedimage $= "" || %mountedimage $= 0) %mountedimage = -1;

  $EZM_ZombieAppearances[%name,%i,"Appearance"] = %appearance;
  $EZM_ZombieAppearances[%name,%i,"HideNodes"] = %hidenodes;
  $EZM_ZombieAppearances[%name,%i,"FaceDecal"] = %facedecal;
  $EZM_ZombieAppearances[%name,%i,"ChestDecal"] = %chestdecal;
  $EZM_ZombieAppearances[%name,%i,"MountedImage"] = %mountedimage;
}

//### Spawn Functions

function EZM_SpawnZombie(%this,%mini)
{
  if(!isObject(%this)) return;
  if(!isObject(%mini)) return;
  if(%mini.EZM_IsSpecialWave) %len = %mini.EZM_SpecialWaveZombieType;
  else
  {
    %len = %rnd = 0;
    %propability = $EZM_Zombies[0,"Propability"];
    while($EZM_Zombies[%len + 1,"Name"] !$= "")
    {
      %len += 1;
      %allow = -1;
      if($EZM_Zombies[%len,"Allow"] !$= -1) eval("%allow = %mini." @ $EZM_Zombies[%len,"Allow"] @ "; $evalNoError = 0;");
      if(%allow != 0) %propability += $EZM_Zombies[%len,"Propability"];
    }
    %rnd = getRandom(%propability);
    %len = 0;
    while($EZM_Zombies[%len,"Name"] !$= "")
    {
      %allow = -1;
      if($EZM_Zombies[%len,"Allow"] !$= -1) eval("%allow = %mini." @ $EZM_Zombies[%len,"Allow"] @ "; $evalNoError = 0;");
      if(%allow != 0)
      {
        if($EZM_Zombies[%len,"Propability"] < %rnd)
        {
          %rnd -= $EZM_Zombies[%len,"Propability"];
          %len += 1;
        }
        else
          break;
      }
      else
        %len += 1;
    }
  }
  %name = $EZM_Zombies[%len,"Name"];
  %namelist = $EZM_Zombies[%len,"Namelist"];
  %db = $EZM_Zombies[%len,"Datablock"];
  %playersize = $EZM_Zombies[%len,"PlayerSize"];
  %melee = $EZM_Zombies[%len,"Melee"];
  %ranged = $EZM_Zombies[%len,"Ranged"];

  %intelligence = mClampF(%mini.EZM_ZombieIntelligence + %mini.EZM_ZombieIntelligenceInc,0,100);
  if(%db $= "") return;
  %this.bot = new AIPlayer()
  {
    dataBlock = %db;
    position = %this.getPosition();
    EZMisZombie = true;
    home = %this;
    intelligence = %intelligence;
    sightRange = 50 + (%intelligence * 4.5);
    attackRange = 5;
    minigame = %mini;
    name = %namelist;
  };
  if(isObject(%this.bot))
  {
    %this.bot.setPlayerScale(%playersize);
    %this.bot.spawnexplosion(SpawnProjectile,%this.bot.getScale());
    %this.bot.hType = "enemy";
    %mini.EZM_ZombieCount += 1;
    %mini.EZM_ZombieWaveCount -= 1;
    %this.bot.EZM_Idle();
    %this.bot.client = %this.bot;
    EZMZombies.add(%this.bot);

    %len = %rnd = 0;
    while($EZM_ZombieAppearances[%name,%len,"Appearance"] !$= "") %len += 1;
    %rnd = getRandom(%len - 1);

    %app = $EZM_ZombieAppearances[%name,%rnd,"Appearance"];
    %hide = $EZM_ZombieAppearances[%name,%rnd,"HideNodes"];
    %face = $EZM_ZombieAppearances[%name,%rnd,"FaceDecal"];
    %chest = $EZM_ZombieAppearances[%name,%rnd,"ChestDecal"];
    %image = $EZM_ZombieAppearances[%name,%rnd,"MountedImage"];

    if(%app != -1) {
      for(%i=0;%i<getWordCount(%app);%i++) {
        %this.bot.unHideNode(getWord(%app,%i));
        %this.bot.setNodeColor(getWord(%app,%i),getWords(%app,%i + 1,%i + 4));
        %i += 4; }
    }
    if(%hide != -1) { for(%i=0;%i<getWordCount(%hide);%i++) { %this.bot.hideNode(getWord(%hide,%i)); } }
    %this.bot.setFaceName(getWord(%face,getRandom(getWordCount(%face)-1)));
    %this.bot.setDecalName(getWord(%chest,getRandom(getWordCount(%chest)-1)));
    if(%image != -1) %this.bot.mountImage(%image,2);

    %rnd = 0;
    if(%mini.EZM_ZombieWeapons == 0)
      %weapon = 1;
    else if(%mini.EZM_ZombieWeapons == 1)
      %weapon = 2;
    else
    {
      if(getRandom(3)) %weapon = 1;
      else
        %weapon = 2;
    }
    if(%ranged == -1) %weapon = 1;
    if(%melee == -1) %weapon = 2;
    if(%weapon == 1) {
      %rnd = getRandom(0,getWordCount(%melee) - 1);
      %this.bot.mountImage(getWord(%melee,%rnd),0); }
    else {
      %rnd = getRandom(0,getWordCount(%ranged) - 1);
      %this.bot.mountImage(getWord(%ranged,%rnd),0);
      %this.bot.attackRange = %this.bot.sightRange / 2; }
    if(%this.bot.getMountedImage(0).armReady) %this.bot.playThread(0,"armReadyRight");
    if(%mini.EZM_SuddenDeathTimeLimit)
    {
      %timediff = (%mini.EZM_SuddenDeathTimeLimit*60) - %mini.EZM_SuddenDeathTimer;
      if(%timediff == 0)
        if(%mini.EZM_SuddenDeath == 0)
          %this.bot.setDamageLevel(%this.bot.maxDamage - 1);
    }
  }
}

function EZM_SpawnBoss(%this,%mini)
{
  if(!isObject(%this)) return;
  if(!isObject(%mini)) return;

  %len = %rnd = 0;
  %propability = $EZM_Bosses[0,"Propability"];
  while($EZM_Bosses[%len + 1,"Name"] !$= "")
  {
    %len += 1;
    %allow = -1;
    if($EZM_Bosses[%len,"Allow"] !$= -1) eval("%allow = %mini." @ $EZM_Bosses[%len,"Allow"] @ "; $evalNoError = 0;");
    if(%allow != 0) %propability += $EZM_Bosses[%len,"Propability"];
  }
  %rnd = getRandom(%propability);
  %len = 0;
  while($EZM_Bosses[%len,"Name"] !$= "")
  {
    %allow = -1;
    if($EZM_Bosses[%len,"Allow"] !$= -1) eval("%allow = %mini." @ $EZM_Bosses[%len,"Allow"] @ "; $evalNoError = 0;");
    if(%allow != 0)
    {
      if($EZM_Bosses[%len,"Propability"] < %rnd)
      {
        %rnd -= $EZM_Bosses[%len,"Propability"];
        %len += 1;
      }
      else
        break;
    }
    else
      %len += 1;
  }
  %name = $EZM_Bosses[%len,"Name"];
  %namelist = $EZM_Bosses[%len,"Namelist"];
  %db = $EZM_Bosses[%len,"Datablock"];
  %playersize = $EZM_Bosses[%len,"PlayerSize"];
  %melee = $EZM_Bosses[%len,"Melee"];
  %ranged = $EZM_Bosses[%len,"Ranged"];

  %intelligence = mClampF(%mini.EZM_ZombieIntelligence + %mini.EZM_ZombieIntelligenceInc,0,100);
  if(%db $= "") return;
  %this.bot = new AIPlayer()
  {
    dataBlock = %db;
    position = %this.getPosition();
    EZMisZombie = true;
    EZMisBoss = true;
    home = %this;
    intelligence = %intelligence;
    sightRange = 50 + (%intelligence * 4.5);
    attackRange = 5;
    minigame = %mini;
    name = %namelist;
  };
  if(isObject(%this.bot))
  {
    %this.bot.setPlayerScale(%playersize);
    %this.bot.spawnexplosion(SpawnProjectile,%this.bot.getScale());

    %rnd = getRandom(11);
    %prefix = "\c3The mighty";
    if(%rnd == 1) %prefix = "\c3The treacherous";
    else if(%rnd == 2) %prefix = "\c3The terrible";
    else if(%rnd == 3) %prefix = "\c3Behold, ";
    else if(%rnd == 4) %prefix = "\c3Behold, ";
    else if(%rnd == 5) %prefix = "\c3Behold, the mighty";
    else if(%rnd == 6) %prefix = "\c3Behold, the treacherous";
    else if(%rnd == 7) %prefix = "\c3Behold, the terrible";
    else if(%rnd == 8) %prefix = "\c3Heads will roll, for";
    else if(%rnd == 9) %prefix = "\c3Heads will roll, as the mighty";
    else if(%rnd == 10) %prefix = "\c3Heads will roll, for the treacherous";
    else if(%rnd == 11) %prefix = "\c3Heads will roll, as the terrible";
    %rnd = getRandom(2);
    %suffix = " \c3 has appeard!";
    if(%rnd == 1) %suffix = " \c3 stepped out of his grave!";
    else if(%rnd == 2) %suffix = " \c3 has returned from the dead!";
    %mini.messageAll(0,%prefix @ " \c0" @ %this.bot.name @ %suffix);
    %mini.EZM_ZombieCount += 1;
    %mini.EZM_BossCount -= 1;
    %this.bot.EZM_Idle();
    %this.bot.client = %this.bot;
    EZMZombies.add(%this.bot);

    %len = %rnd = 0;
    while($EZM_ZombieAppearances[%name,%len,"Appearance"] !$= "") %len += 1;
    %rnd = getRandom(%len - 1);

    %app = $EZM_ZombieAppearances[%name,%rnd,"Appearance"];
    %hide = $EZM_ZombieAppearances[%name,%rnd,"HideNodes"];
    %face = $EZM_ZombieAppearances[%name,%rnd,"FaceDecal"];
    %chest = $EZM_ZombieAppearances[%name,%rnd,"ChestDecal"];
    %image = $EZM_ZombieAppearances[%name,%rnd,"MountedImage"];

    if(%app != -1) {
      for(%i=0;%i<getWordCount(%app);%i++) {
        %this.bot.unHideNode(getWord(%app,%i));
        %this.bot.setNodeColor(getWord(%app,%i),getWords(%app,%i + 1,%i + 4));
        %i += 4; }
    }
    if(%hide != -1) { for(%i=0;%i<getWordCount(%hide);%i++) { %this.bot.hideNode(getWord(%hide,%i)); } }
    %this.bot.setFaceName(getWord(%face,getRandom(getWordCount(%face)-1)));
    %this.bot.setDecalName(getWord(%chest,getRandom(getWordCount(%chest)-1)));
    if(%image != -1) %this.bot.mountImage(%image,2);

    %rnd = 0;
    %this.bot.playThread(0,"armReadyRight");
    if(%mini.EZM_ZombieWeapons == 0)
      %weapon = 1;
    else if(%mini.EZM_ZombieWeapons == 1)
      %weapon = 2;
    else
    {
      if(getRandom(1)) %weapon = 1;
      else
        %weapon = 2;
    }
    if(%ranged == -1) %weapon = 1;
    if(%melee == -1) %weapon = 2;
    if(%weapon == 1) {
      %rnd = getRandom(0,getWordCount(%melee) - 1);
      %this.bot.mountImage(getWord(%melee,%rnd),0); }
    else {
      %rnd = getRandom(0,getWordCount(%ranged) - 1);
      %this.bot.mountImage(getWord(%ranged,%rnd),0);
      %this.bot.attackRange = %this.bot.sightRange / 2; }
  }
}
