//########## The actual Zombies

//### Sounds

datablock AudioProfile(EZM_ZombieJumpSound)
{
  filename = "./ZombieJump.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(EZM_ZombiePainSound)
{
  filename = "./ZombiePain.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(EZM_ZombieDeathSound)
{
  filename = "./ZombieDeath.wav";
  description = AudioClose3d;
  preload = true;
};

//### Effects

datablock ParticleData(EZM_KompressorSmokeParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = -1;
  inheritedVelFactor = 0.5;
  constantAcceleration = 0;
  lifetimeMS = 2000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0 0 0 0";
  colors[1] = "0 0 0 0.25";
  colors[2] = "0.5 0 1 0";
  sizes[0] = 1;
  sizes[1] = 2;
  sizes[2] = 1;
  times[0] = 0;
  times[1] = 0.5;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(EZM_KompressorSmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 30;
  periodVarianceMS = 0;
  ejectionVelocity = 1;
  velocityVariance = 1;
  ejectionOffset = 1;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "EZM_KompressorSmokeParticle";
};

//### Images

datablock ShapeBaseImageData(EZM_RibcageImage)
{
  shapeFile = "./ribcage.dts";
  emap = true;
  mountPoint = 7;
  offset = "0 0 0.62";
  eyeOffset = "0 0 10";
  rotation = eulerToMatrix("0 0 0");
  scale = "1 1 1";
  correctMuzzleVector = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Idle";
  stateAllowImageChange[0] = true;
};

datablock ShapeBaseImageData(EZM_KompressorImage)
{
  shapeFile = "./ribcage.dts";
  emap = true;
  mountPoint = 7;
  offset = "0 0 0.62";
  eyeOffset = "0 0 10";
  doColorShift = true;
  colorShiftColor = "0 0 0 1";

  stateName[0] = "Smoke";
  stateTransitionOnTimeout[0] = "Smoke";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 1000;
  stateEmitter[0] = EZM_KompressorSmokeEmitter;
  stateEmitterTime[0] = 1000;
};

//### Player Datablocks

datablock PlayerData(EZM_FastPlayer : PlayerStandardArmor)
{
  uiName = "";
  maxDamage = 50;
  jumpForce = 1000;
  maxForwardSpeed = 10;
  maxBackwardSpeed = 6;
  maxSideSpeed = 8;
  maxForwardCrouchSpeed = 5;
  maxBackwardCrouchSpeed = 3;
  maxSideCrouchSpeed = 3;
  canJet = false;
};

datablock PlayerData(EZM_SkeletonPlayer : PlayerStandardArmor)
{
  uiName = "";
  maxDamage = 50;
  jumpForce = 1200;
  maxForwardSpeed = 10;
  maxBackwardSpeed = 6;
  maxSideSpeed = 8;
  maxForwardCrouchSpeed = 5;
  maxBackwardCrouchSpeed = 3;
  maxSideCrouchSpeed = 3;
  canJet = false;
};

datablock PlayerData(EZM_SlowPlayer : PlayerStandardArmor)
{
  uiName = "";
  maxDamage = 200;
  jumpForce = 800;
  maxForwardSpeed = 6;
  maxBackwardSpeed = 3;
  maxSideSpeed = 5;
  maxForwardCrouchSpeed = 2;
  maxBackwardCrouchSpeed = 1.5;
  maxSideCrouchSpeed = 1.5;
  canJet = false;
};

datablock PlayerData(EZM_NormalPlayer : PlayerStandardArmor)
{
  uiName = "";
  canJet = false;
};

datablock PlayerData(EZM_HeavyPlayer : PlayerStandardArmor)
{
  uiName = "";
  maxDamage = 400;
  jumpForce = 800;
  maxForwardSpeed = 5;
  maxBackwardSpeed = 2;
  maxSideSpeed = 4;
  maxForwardCrouchSpeed = 1.5;
  maxBackwardCrouchSpeed = 1;
  maxSideCrouchSpeed = 1;
  canJet = false;
};

datablock PlayerData(EZM_BossPlayer : PlayerStandardArmor)
{
  uiName = "";
  maxDamage = 1000;
  jumpForce = 1000;
  maxForwardSpeed = 5;
  maxBackwardSpeed = 2;
  maxSideSpeed = 4;
  maxForwardCrouchSpeed = 2;
  maxBackwardCrouchSpeed = 1;
  maxSideCrouchSpeed = 1;
  canJet = false;
};

//### Zombies

EZM_addZombie("Skeleton","Skeleton",EZM_SkeletonPlayer,"1 1 1",0,0,1,10,"EZM_AllowSkeletons");
EZM_addZombie("Zombie","Zombie",EZM_NormalPlayer,"1 1 1",0,0,0,10,"EZM_AllowNormalZombies");
EZM_addZombie("Fat Zombie","Fat Zombie",EZM_SlowPlayer,"1.2 1.2 1",0,0,0,10,"EZM_AllowFatZombies");
EZM_addZombie("Soldier Zombie","Soldier Zombie",EZM_HeavyPlayer,"1 1 1",-1,"EZM_GunImage EZM_AkimboGunImage",1,2,"EZM_AllowSoldierZombies");
EZM_addZombie("Demolition Zombie","Demolition Zombie",EZM_HeavyPlayer,"1 1 1",-1,"EZM_DynamiteImage",1,2,"EZM_AllowSoldierZombies");
EZM_addZombie("Rocket Zombie","Rocket Zombie",EZM_HeavyPlayer,"1 1 1",-1,"EZM_RocketLauncherImage",1,2,"EZM_AllowSoldierZombies");
EZM_addZombie("Suicidal Zombie","Suicidal Zombie",EZM_FastPlayer,"1 1 1","EZM_DynamiteInstantImage",-1,1,2,"EZM_AllowSuicidalZombies");
EZM_addZombie("Ninja Zombie","Ninja Zombie",EZM_FastPlayer,"1 1 1","EZM_SwordImage","EZM_ShurikenImage",1,3,"EZM_AllowNinjaZombies");

//### Zombie Appearances

EZM_addAppearance("Skeleton","headskin 1 1 1 1 lhand 1 1 1 1 rhand 1 1 1 1 larmslim 1 1 1 1 rarmslim 1 1 1 1 lshoe 1 1 1 1 rshoe 1 1 1 1","larm rarm chest pants","Skull","AAA-None",EZM_RibcageImage);

EZM_addAppearance("Zombie","headskin 0.54 0.7 0.55 1 lhand 0.54 0.7 0.55 1 rhand 0.54 0.7 0.55 1 chest 1 1 1 1 larm 0.9 0 0 1 rarm 0.9 0 0 1 pants 0.2 0 0.8 1 lshoe 0.2 0 0.8 1 rshoe 0.2 0 0.8 1",0,"Skull","AAA-None");
EZM_addAppearance("Zombie","headskin 0.54 0.7 0.55 1 lhand 0.54 0.7 0.55 1 rhand 0.54 0.7 0.55 1 chest 0.1 0.1 0.1 1 larm 0.1 0.1 0.1 1 rarm 0.1 0.1 0.1 1 pants 0.1 0.1 0.1 1 lshoe 0.1 0.1 0.1 1 rshoe 0.1 0.1 0.1 1",0,"Skull","Mod-Suit");
EZM_addAppearance("Zombie","headskin 0.54 0.7 0.55 1 lhand 0.54 0.7 0.55 1 rhand 0.54 0.7 0.55 1 chest 0.5 0.5 0.5 1 larm 0.5 0.5 0.5 1 rarm 0.5 0.5 0.5 1 pants 0.5 0.5 0.5 1 lshoe 0.1 0.1 0.1 1 rshoe 0.1 0.1 0.1 1",0,"Skull","Mod-Suit");
EZM_addAppearance("Zombie","headskin 0.54 0.7 0.55 1 lhand 0.54 0.7 0.55 1 rhand 0.54 0.7 0.55 1 chest 0 0 0.5 1 larm 0 0 0.5 1 rarm 0 0 0.5 1 pants 0 0 0.5 1 lshoe 0.1 0.1 0.1 1 rshoe 0.1 0.1 0.1 1",0,"Skull","Mod-Suit");
EZM_addAppearance("Zombie","headskin 0.54 0.7 0.55 1 lhand 0.54 0.7 0.55 1 rhand 0.54 0.7 0.55 1 chest 0 0 0.5 1 larm 0 0 0.5 1 rarm 0 0 0.5 1 pants 0 0 0.5 1 lshoe 0.1 0.1 0.1 1 rshoe 0.1 0.1 0.1 1",0,"Skull","Mod-Police");
EZM_addAppearance("Zombie","headskin 0.54 0.7 0.55 1 lhand 0.54 0.7 0.55 1 rhand 0.54 0.7 0.55 1 chest 1 0.5 0 1 larm 1 0.5 0 1 rarm 1 0.5 0 1 pants 1 0.5 0 1 lshoe 0.1 0.1 0.1 1 rshoe 0.1 0.1 0.1 1",0,"Skull","Mod-Prisoner");
EZM_addAppearance("Zombie","headskin 0.54 0.7 0.55 1 lhand 0.54 0.7 0.55 1 rhand 0.54 0.7 0.55 1 chest 0.1 0.1 0.1 1 larm 0.1 0.1 0.1 1 rarm 0.1 0.1 0.1 1 pants 0.1 0.1 0.1 1 lshoe 0.1 0.1 0.1 1 rshoe 0.1 0.1 0.1 1",0,"Skull","Chef");
EZM_addAppearance("Zombie","headskin 0.54 0.7 0.55 1 lhand 0.54 0.7 0.55 1 rhand 0.54 0.7 0.55 1 chest 1 1 1 1 larm 1 1 1 1 rarm 1 1 1 1 pants 1 1 1 1 lshoe 0.1 0.1 0.1 1 rshoe 0.1 0.1 0.1 1",0,"Skull","Chef");
EZM_addAppearance("Zombie","headskin 0.54 0.7 0.55 1 lhand 0.54 0.7 0.55 1 rhand 0.54 0.7 0.55 1 chest 1 1 1 1 larm 0.5 0 0 1 rarm 0.5 0 0 1 pants 0 0 0.5 1 lshoe 0.1 0.1 0.1 1 rshoe 0.1 0.1 0.1 1",0,"Skull","Hoodie");
EZM_addAppearance("Zombie","headskin 0.54 0.7 0.55 1 lhand 0.54 0.7 0.55 1 rhand 0.54 0.7 0.55 1 chest 1 1 1 1 larm 0.5 0.5 0.5 1 rarm 0.5 0.5 0.5 1 pants 0.1 0.1 0.1 1 lshoe 0.1 0.1 0.1 1 rshoe 0.1 0.1 0.1 1",0,"Skull","Hoodie");

EZM_addAppearance("Fat Zombie","headskin 0.54 0.7 0.55 1 lhand 0.54 0.7 0.55 1 rhand 0.54 0.7 0.55 1 chest 1 1 1 1 larm 0.9 0 0 1 rarm 0.9 0 0 1 pants 0.2 0 0.8 1 lshoe 0.2 0 0.8 1 rshoe 0.2 0 0.8 1",0,"Skull","AAA-None");
EZM_addAppearance("Fat Zombie","headskin 0.54 0.7 0.55 1 lhand 0.54 0.7 0.55 1 rhand 0.54 0.7 0.55 1 chest 0.1 0.1 0.1 1 larm 0.1 0.1 0.1 1 rarm 0.1 0.1 0.1 1 pants 0.1 0.1 0.1 1 lshoe 0.1 0.1 0.1 1 rshoe 0.1 0.1 0.1 1",0,"Skull","Mod-Suit");
EZM_addAppearance("Fat Zombie","headskin 0.54 0.7 0.55 1 lhand 0.54 0.7 0.55 1 rhand 0.54 0.7 0.55 1 chest 0.5 0.5 0.5 1 larm 0.5 0.5 0.5 1 rarm 0.5 0.5 0.5 1 pants 0.5 0.5 0.5 1 lshoe 0.1 0.1 0.1 1 rshoe 0.1 0.1 0.1 1",0,"Skull","Mod-Suit");
EZM_addAppearance("Fat Zombie","headskin 0.54 0.7 0.55 1 lhand 0.54 0.7 0.55 1 rhand 0.54 0.7 0.55 1 chest 0 0 0.5 1 larm 0 0 0.5 1 rarm 0 0 0.5 1 pants 0 0 0.5 1 lshoe 0.1 0.1 0.1 1 rshoe 0.1 0.1 0.1 1",0,"Skull","Mod-Suit");
EZM_addAppearance("Fat Zombie","headskin 0.54 0.7 0.55 1 lhand 0.54 0.7 0.55 1 rhand 0.54 0.7 0.55 1 chest 0 0 0.5 1 larm 0 0 0.5 1 rarm 0 0 0.5 1 pants 0 0 0.5 1 lshoe 0.1 0.1 0.1 1 rshoe 0.1 0.1 0.1 1",0,"Skull","Mod-Police");
//EZM_addAppearance("Fat Zombie","headskin 0.54 0.7 0.55 1 lhand 0.54 0.7 0.55 1 rhand 0.54 0.7 0.55 1 chest 1 0.5 0 1 larm 1 0.5 0 1 rarm 1 0.5 0 1 pants 1 0.5 0 1 lshoe 0.1 0.1 0.1 1 rshoe 0.1 0.1 0.1 1",0,"Skull","Mod-Prisoner");
EZM_addAppearance("Fat Zombie","headskin 0.54 0.7 0.55 1 lhand 0.54 0.7 0.55 1 rhand 0.54 0.7 0.55 1 chest 0.1 0.1 0.1 1 larm 0.1 0.1 0.1 1 rarm 0.1 0.1 0.1 1 pants 0.1 0.1 0.1 1 lshoe 0.1 0.1 0.1 1 rshoe 0.1 0.1 0.1 1",0,"Skull","Chef");
EZM_addAppearance("Fat Zombie","headskin 0.54 0.7 0.55 1 lhand 0.54 0.7 0.55 1 rhand 0.54 0.7 0.55 1 chest 1 1 1 1 larm 1 1 1 1 rarm 1 1 1 1 pants 1 1 1 1 lshoe 0.1 0.1 0.1 1 rshoe 0.1 0.1 0.1 1",0,"Skull","Chef");
EZM_addAppearance("Fat Zombie","headskin 0.54 0.7 0.55 1 lhand 0.54 0.7 0.55 1 rhand 0.54 0.7 0.55 1 chest 1 1 1 1 larm 0.5 0 0 1 rarm 0.5 0 0 1 pants 0 0 0.5 1 lshoe 0.1 0.1 0.1 1 rshoe 0.1 0.1 0.1 1",0,"Skull","Hoodie");
EZM_addAppearance("Fat Zombie","headskin 0.54 0.7 0.55 1 lhand 0.54 0.7 0.55 1 rhand 0.54 0.7 0.55 1 chest 1 1 1 1 larm 0.5 0.5 0.5 1 rarm 0.5 0.5 0.5 1 pants 0.1 0.1 0.1 1 lshoe 0.1 0.1 0.1 1 rshoe 0.1 0.1 0.1 1",0,"Skull","Hoodie");

EZM_addAppearance("Soldier Zombie","headskin 0.56 0.93 0.96 1 lhand 0.56 0.93 0.96 1 rhand 0.56 0.93 0.96 1 chest 0.2 0.4 0.2 1 larm 0.2 0.4 0.2 1 rarm 0.2 0.4 0.2 1 pants 0.2 0.4 0.2 1 lshoe 0.1 0.1 0.1 1 rshoe 0.1 0.1 0.1 1 armor 0.1 0.1 0.1 1 helmet 0.2 0.4 0.2 1 epauletsrankd 1 1 0 1",0,"Skull","AAA-None");

EZM_addAppearance("Demolition Zombie","headskin 0.56 0.93 0.96 1 lhand 0.56 0.93 0.96 1 rhand 0.56 0.93 0.96 1 chest 1 0 0 1 larm 1 0 0 1 rarm 1 0 0 1 pants 1 0 0 1 lshoe 0.1 0.1 0.1 1 rshoe 0.1 0.1 0.1 1 armor 0.1 0.1 0.1 1 helmet 1 0 0 1 epauletsrankd 1 1 0 1",0,"Skull","AAA-None");

EZM_addAppearance("Rocket Zombie","headskin 0.56 0.93 0.96 1 lhand 0.56 0.93 0.96 1 rhand 0.56 0.93 0.96 1 chest 1 0 0 1 larm 1 0 0 1 rarm 1 0 0 1 pants 1 0 0 1 lshoe 0.1 0.1 0.1 1 rshoe 0.1 0.1 0.1 1 armor 0.1 0.1 0.1 1 helmet 1 0 0 1 epauletsrankd 1 1 0 1",0,"Skull","AAA-None");

EZM_addAppearance("Suicidal Zombie","headskin 0.54 0.7 0.55 1 lhand 0.54 0.7 0.55 1 rhand 0.54 0.7 0.55 1 chest 1 0 0 1 larm 1 1 1 1 rarm 1 1 1 1 pants 0.2 0 0.8 1 lshoe 0.2 0 0.8 1 rshoe 0.2 0 0.8 1",0,"Skull","AAA-None");

EZM_addAppearance("Ninja Zombie","headskin 1 1 1 1 lhand 0 0 0 1 rhand 0 0 0 1 chest 0 0 0 1 larm 0 0 0 1 rarm 0 0 0 1 pants 0 0 0 1 lshoe 0 0 0 1 rshoe 0 0 0 1",0,"Skull","AAA-None");

//### Bosses

EZM_addBoss("Major Nutcrunch","Major Nutcrunch",EZM_BossPlayer,"1.5 1.5 1.5",-1,"EZM_RocketLauncherImage",5,"EZM_AllowSoldierZombies");

EZM_addBoss("Badspot","Badspot",EZM_BossPlayer,"2 2 2",-1,"EZM_DeathWandImage",5,"EZM_AllowNormalZombies");

EZM_addBoss("Kompressor","Kompressor",EZM_BossPlayer,"2 2 2",-1,"EZM_KompressorWandImage",5,"EZM_AllowNormalZombies");

//### Boss Appearances

EZM_addAppearance("Major Nutcrunch","headskin 0.56 0.93 0.96 1 lhand 0.56 0.93 0.96 1 rhand 0.56 0.93 0.96 1 chest 0.2 0.4 0.2 1 larm 0.2 0.4 0.2 1 rarm 0.2 0.4 0.2 1 pants 0.2 0.4 0.2 1 lshoe 0.1 0.1 0.1 1 rshoe 0.1 0.1 0.1 1 armor 0.1 0.1 0.1 1 helmet 0.2 0.4 0.2 1 epauletsrankb 1 1 0 1",0,"Skull","AAA-None");

EZM_addAppearance("Badspot","headskin 0.54 0.7 0.55 1 lhand 0.54 0.7 0.55 1 rhand 0.54 0.7 0.55 1 chest 1 1 1 1 larm 0.9 0 0 1 rarm 0.9 0 0 1 pants 0.2 0 0.8 1 lshoe 0.2 0 0.8 1 rshoe 0.2 0 0.8 1",0,"Skull","AAA-None");

EZM_addAppearance("Kompressor","headskin 0.56 0.93 0.96 1 lhand 0.56 0.93 0.96 1 rhand 0.56 0.93 0.96 1 larm 0 0 0 1 rarm 0 0 0 1 lshoe 0 0 0 1 rshoe 0 0 0 1 cape 0.5 0 1 1","chest pants","Skull","AAA-None",EZM_KompressorImage);
